<template>
    <div class="flex">
        <button @click="open(options)" type="button" :disabled="loading"
            class="flex items-center hover:bg-blue-600 bg-blue-700 mr-4 px-4 py-2 rounded">
            <svg style="width: 24px; height: 24px" viewBox="0 0 24 24" class="mr-2">
                <path fill="currentColor" d="M9,16V10H5L12,3L19,10H15V16H9M5,20V18H19V20H5Z" />
            </svg>
            Upload
        </button>
        <div v-if="error" class="place-self-center text-red-600">{{ error }}</div>
        <Spinner v-show="loading" :size="30" class="ml-2" />
    </div>
</template>

<script lang="ts" setup>
import axios from "axios";
import { useFileDialog, UseFileDialogOptions } from "@vueuse/core";
import { ref } from "vue";

const loading = ref(false);

const options = {
    multiple: false,
    accept: ".jar",
} as UseFileDialogOptions;

const error = ref("");

const { files, open, reset, onChange } = useFileDialog();

onChange((files) => {
    console.log(files);

    if (files === null) return;

    loading.value = true;

    axios
        .post(`${window.origin}/api/modules`, files[0], {
            headers: {
                "Content-Type": "application/java-archive",
            },
        })
        .catch((err) => {
            error.value = err;
            console.log(err);
        })
        .finally(() => {
            loading.value = false;
        });
});
</script>
